/*
Copyright (C) 2006-2007 by Carlos H. P. da Silva <carloshp.silva@gmail.com>.

This file is part of LameScript 2.0.

    LameScript is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
// ====================================================================
// lsdefs.h
// ====================================================================

#ifndef		_LSDEFS_H
#define		_LSDEFS_H	1
#define		LSVERSION	2
#define		LSRELEASE	0
#include "stdio.h"
#include "stdarg.h"
#include "lshash.h"
// ====================================================================
// LameScript limits
//
#define	MAXVALNUM			65536
#define	MAXVALSIZE			1024
#define	MAXPATHSIZE			1024

// ====================================================================
// These are control symbols used during script parsing
//
#define	LSTOK_BOF			0x0000
#define	LSTOK_COMMENT		0x0001
#define	LSTOK_STARTSECTION	0x0002
#define	LSTOK_STARTKEY		0x0003
#define	LSTOK_STARTVALUE	0x0004
#define	LSTOK_ENDSECTION	0x0012
#define	LSTOK_ENDKEY		0x0013
#define	LSTOK_ENDVALUE		0x0014
// ====================================================================
// LameScript error codes
//
#define	LSOK				0x0000
#define	LS_NOINIT			0x0001
#define	LS_NOSCRIPT			0x0002
#define	LS_NOSECTION		0x0003
#define	LS_NOKEY			0x0004
#define	LS_BADPATH			0x0005
#define	LS_FULLKEY			0x0006
#define	LS_BADKEYINDEX		0x0007
#define	LS_BADSCRIPT		0x0008
#define	LS_BADHASHCODE		0x0009
// ====================================================================

int		LS_init (void);
int		LS_getStatus (void);
int		LS_setPath (char *fmt, ...);
char*	LS_getPath (void);
int		LS_setScript (char *name);
int		LS_delScript (char *name);
int		LS_getScriptCount (void);
int		LS_setSection (char *name);
int		LS_delSection (char *name);
int		LS_getSectionCount (void);
int		LS_setKey (char *name);
int		LS_delKey (char *name);
int		LS_getKeyCount (void);
void	LS_addValue (char *value);
void	LS_setValue (char *value, int position);
char*	LS_getValue (int position);
int		LS_getIterator (int position);
int		LS_hasNext (void);
char*	LS_nextValue (void);
int		LS_getValueCount (void);
int		LS_saveScript (char *filename);
int		LS_saveScriptFile (FILE *fout);
int		LS_loadScript (char *filename, char *alias);
int		LS_loadScriptFile (FILE *fin, char *alias);
#endif
