/*
Copyright (C) 2006-2007 by Carlos H. P. da Silva <carloshp.silva@gmail.com>.

This file is part of LameScript 2.0.

    LameScript is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
// ====================================================================
// lshash.h
// ====================================================================

#ifndef _LSHASH_H
#define	_LSHASH_H	1
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <ctype.h>

// ====================================================================
#define	HASHBUCKETS	64
// ====================================================================
typedef struct
{
	char	*name;
	void	*item;
	void	*next;
}lshitem_t;

typedef struct
{
	int			count;
	char		*name;
	lshitem_t	*items[HASHBUCKETS];
}lshash_t;

// ====================================================================
int			_getHashCode (char *name);
lshash_t*	_newHashTable (char *name);
int			_setHashTableItem (lshash_t *hash, char *name, void *item);
void*		_getHashTableItem (lshash_t *hash, char *name);
int			_delHashTableItem (lshash_t *hash, char *name);
int			_getHashTableCount (lshash_t *hash);
void		_clearHashTable (lshash_t *hash);
int			_setHashTableIterator (lshash_t *hash, char *name);
void*		_nextHashTableItem (void);
int			_hasNextHashTableItem (void);
#endif